/*---------------------------------------------------------------------------*
Project: NitroWiFi - shared - demos
File: ap_info.c

Copyright 2005.2006 Nintendo.  All rights reserved.

These coded instructions, statements, and computer programs contain
proprietary information of Nintendo of America Inc. and/or Nintendo
Company Ltd., and are protected by Federal copyright law.  They may
not be disclosed to third parties or copied or duplicated in any form,
in whole or in part, without the prior written consent of Nintendo.

$Log: ap_info.c,v $
Revision 1.4  03/15/2006 10:07:24  kitase_hirotake
  INDENT-OFF additions

Revision 1.3  03/10/2006 09:22:42  kitase_hirotake
  INDENT SOURCE

Revision 1.2  2005/11/02 04:13:42  terui
Fix comment.

Revision 1.1  07/21/2005 08:38:16  terui
Added new source files common to samples

$NoKeywords: $
 *---------------------------------------------------------------------------*/
#include "ap_info.h"

/*---------------------------------------------------------------------------*
< AP information > Please edit this file definition to match the AP to connect to.

If you choose not to edit them, the settings will be: any BSS-ID, any ESS-ID, system authentication and no WEP encryption.
open system verification and no WEP encryption will remain.
 *---------------------------------------------------------------------------*/
#define LOCAL_WCM_WEP_MODE  WCM_WEPMODE_NONE

/* *INDENT-OFF* */
SDK_WEAK_SYMBOL const WcmControlApInfo  constApInfo =
{
    { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff } ,        // BSS-ID

    {
        LOCAL_WCM_WEP_MODE ,                        // WEP encryption mode
        0 ,                                         // WEP key number

        /* WEP key data string */
#if     ( LOCAL_WCM_WEP_MODE == WCM_WEPMODE_40 )
        {
            0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        }
#elif   ( LOCAL_WCM_WEP_MODE == WCM_WEPMODE_104 )
        {
            0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        }
#elif   ( LOCAL_WCM_WEP_MODE == WCM_WEPMODE_128 )
        {
            0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
            0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00
        }
#else /* ( LOCAL_WCM_WEP_MODE == WCM_WEPMODE_NONE ) */
        {
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        }
#endif
    } ,

    { "" } ,                                        // ESS-ID

    WCM_OPTION_AUTH_OPENSYSTEM                      // 802.11 authentication mode
};
/* *INDENT-ON* */

/*---------------------------------------------------------------------------*
End of file
 *---------------------------------------------------------------------------*/
