/*---------------------------------------------------------------------------*
Project: NitroWiFi - SSL - demos - ssl-1
File: wcm_control.h

Copyright 2005.2006 Nintendo.  All rights reserved.

These coded instructions, statements, and computer programs contain
proprietary information of Nintendo of America Inc. and/or Nintendo
Company Ltd., and are protected by Federal copyright law.  They may
not be disclosed to third parties or copied or duplicated in any form,
in whole or in part, without the prior written consent of Nintendo.

$Log: wcm_control.h,v $
Revision 1.3  03/10/2006 09:22:42  kitase_hirotake
  INDENT SOURCE

Revision 1.2  2005/11/02 02:41:33  terui
Fix comment.

Revision 1.1  07/21/2005 11:47:03  seiki_masashi
moved ssl to ssl-1

Revision 1.1  07/18/2005 08:10:26  seiki_masashi
added ssl-1 demo

$NoKeywords: $
 *---------------------------------------------------------------------------*/
#ifndef WCM_CONTROL_H_
#define WCM_CONTROL_H_

#ifdef __cplusplus

extern "C" {
#endif

/*===========================================================================*/

/*---------------------------------------------------------------------------*
Name: InitWcmControl

Description: Initializes internal variables and launches the WCM control thread.
Nothing is performed if the thread has already been launched.

Arguments: None.

Returns: None.
 *---------------------------------------------------------------------------*/
void    InitWcmControl(void);

/*---------------------------------------------------------------------------*
Name: TerminateWcmControl

Description: Ends the WCM control thread.
Nothing is performed if the thread has not been launched.
NOTICE: As this function only serves as a trigger to end the thread,
be aware that it will return without waiting for the thread itself to end.
If you want to wait for the thread itself to end, you will need to call
OS_JoinThread after calling OS_SendMessage.
In addition, if the WCM_GetPhase is set to return WCM_PHASE_NULL,
the thread has ended.

Arguments: None.

Returns: None.
 *---------------------------------------------------------------------------*/
void    TerminateWcmControl(void);

/*===========================================================================*/
#ifdef __cplusplus

}       /* extern "C" */
#endif

#endif /* WCM_CONTROL_H_ */

/*---------------------------------------------------------------------------*
End of file
 *---------------------------------------------------------------------------*/
